﻿-- Mailbox Cleaner
-- by Jadya - EU-Well of Eternity

local addonName, addonTable = ...
local min, low = math.min, string.lower

local title = "|cff00FF00"..addonName.."|r"

local snd
local em_enabled = false
local i
local lastindex, timeout = 0,0
local timeout_range = 1 -- one second
local f = CreateFrame("Frame")

local options_desc = { ["read"] = "Delete unread mails" }
MailboxCleaner_Config = { ["read"] = false }

local function endloop()
 em_enabled = false
 f:Hide()
 print(title.." - Finished.")
end

local function update()
 if not em_enabled or not InboxFrame or not InboxFrame:IsVisible() then endloop() return end

 local num = GetInboxNumItems()

 if num < 1 or i < 1 then
  endloop()
  return
 end
 
 local t = time()
 
 if timeout > 0 then
  if i > num or (timeout < t) then
   i = min(i - 1, num)
   timeout = 0
  else
   return
  end
 end

 --canDelete = InboxItemCanDelete(i)
 --if canDelete then
 local packageIcon, stationeryIcon, sender, subject, money, CODAmount, daysLeft, itemCount, wasRead, wasReturned, textCreated, canReply, isGM, itemQuantity = GetInboxHeaderInfo(i)
 if (MailboxCleaner_Config["read"] or wasRead) and not isGM and (not snd or (snd and (snd == low(sender)))) and
  (not itemCount or itemCount == 0) and (not money or money == 0) then
  DeleteInboxItem(i)
  timeout = t + 1
 else
  i = i - 1
 end   
 --end
 
 if i > num then 
  endloop()
 end
end

f:SetScript("OnUpdate", update)
f:Hide()

local function printOptionMsg(arg, help)
 if MailboxCleaner_Config[arg] == nil then return end

 print(title.." - "..(options_desc[arg] or "<unknown>").." = |cff69CCF0"..tostring(MailboxCleaner_Config[arg]).."|r"..
      (help and " (|cffCCCCCC/mbclean "..arg.."|r)" or ""))
end

local function start(arg)

 if arg == "read" then
  MailboxCleaner_Config["read"] = not MailboxCleaner_Config["read"]
  printOptionMsg(arg)
  return
 end

 if not InboxFrame or not InboxFrame:IsVisible() then
  print(title.." - You need to open the mailbox first.")
  return
 end
 if arg and arg ~= "" then
  snd = low(arg)
 else
  snd = nil
 end
 i = GetInboxNumItems()
 print(title.." - Deleting empty mails"..(snd and " from "..snd or "").."...")
 em_enabled = true
 f:Show()
end

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("PLAYER_ENTERING_WORLD")
local function eventhandler()
 print(title.." loaded, type |cff009999/mbclean|r with the mailbox opened to remove empty mails that have been read.")
 print(title.." or type |cff009999/mbclean sendername|r to remove mails from a specified sender.")
 print(title.." - |cff00FFFFOptions set:|r")
 printOptionMsg("read", true)
 eventframe:SetScript("OnEvent", nil)
end
eventframe:SetScript("OnEvent", eventhandler)
-- slash command
SLASH_MAILBOXCLEANER1 = "/mbclean"
SLASH_MAILBOXCLEANER2 = "/mailboxcleaner"
SlashCmdList["MAILBOXCLEANER"] = start